package com.suning.mobile.epa.paymentcode

import android.content.Context
import com.suning.mobile.epa.kits.common.SourceConfig

class PaymentCodeBuilder {

    companion object {
        val builder by lazy {
            Builder()
        }
    }
    class Builder {

        fun setAppId(appId : String) : Builder{
            PaymentCodeGlobalInfo.appId = appId
            return this
        }
        fun setVersion(version : String) : Builder{
            PaymentCodeGlobalInfo.version = version
            return this
        }
        fun setSource(sourceType : SourceConfig.SourceType) : Builder{
            PaymentCodeGlobalInfo.source = sourceType
            return this
        }

        fun setChannel(channel : String) : Builder{
            PaymentCodeGlobalInfo.channel = channel
            return this
        }

        fun setH5CallBack(callBack: PaymentH5CallBack) : Builder{
            PaymentCodeGlobalInfo.h5CallBack = callBack
            return this
        }

        fun setErrorViewCallBack(callBack: PaymentShowErrorView) : Builder{
            PaymentCodeGlobalInfo.errorCallBack = callBack
            return this
        }

    }

    interface PaymentH5CallBack{
        fun gotoH5WebVIew(context: Context, url : String)
    }

    interface PaymentShowErrorView{
        fun showErrorView()
    }
}