package com.suning.mobile.epa.paymentcode.h5

import android.app.Activity
import android.os.Bundle
import android.text.TextUtils
import android.view.View
import android.webkit.CookieManager
import android.webkit.WebView
import android.webkit.WebViewClient
import com.suning.epafusion.R
import com.suning.epafusion.utils.StrsContents
import com.suning.mobile.epa.kits.utils.AppInfoUtil
import com.suning.mobile.epa.kits.utils.DeviceInfoUtil
import com.suning.mobile.epa.kits.utils.LogUtils
import com.suning.mobile.epa.paymentcode.network.PaymentNetworkConfig
import com.suning.mobile.epa.paymentcode.utils.CookieUtils
import kotlinx.android.synthetic.main.activity_payment_h5.*
import org.apache.http.util.EncodingUtils
import org.json.JSONObject
import java.lang.StringBuilder
import java.net.URLDecoder
import java.net.URLEncoder

/**
 * @author zhongchi
 * @date 2019/1/11 11:46
 */
class PaymentPayH5Activity : Activity() {

    interface PayResultListener{
        fun onResult(isSuccess : Boolean)
    }

    companion object {
        var listener : PayResultListener? = null
    }

    private var token = ""
    private var returnUrl = "https://snjr.h5tonative.suning.com/type=doneThenClose"

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_payment_h5)
        backBtn.setOnClickListener {
            if (webView.canGoBack()) {
                webView.goBack()
            }else{
                listener?.onResult(false)
                finish()
            }
        }
        closeBtn.setOnClickListener {
            listener?.onResult(false)
            finish()
        }
        initSetting()
        token = intent.getStringExtra("token")
        CookieUtils.syncCookie(PaymentNetworkConfig.wapPayUrl,this)

        var json = JSONObject()
        json.put("token=", URLEncoder.encode(token, "UTF-8"))
        var str = "token="+token
        LogUtils.d("wapPayUrl","json==1>"+URLEncoder.encode(str, "UTF-8"))
        LogUtils.d("wapPayUrl","json==2>"+ URLDecoder.decode(str, "UTF-8"))
        LogUtils.d("wapPayUrl","json==3>"+ URLEncoder.encode(token, "UTF-8"))
        var sb = StringBuilder()
        sb.append(PaymentNetworkConfig.wapPayUrl).append("?").append(str)
        webView.loadUrl(sb.toString())
       // webView.postUrl(PaymentNetworkConfig.wapPayUrl, EncodingUtils.getBytes(str, "BASE64"))
    }

    override fun onBackPressed() {
        if (webView.canGoBack()) {
            webView.goBack()
            return
        }else{
            listener?.onResult(false)
        }
        super.onBackPressed()
    }

    private fun initSetting(){
        val webSetting = webView.settings
        if (webSetting != null) {
            webSetting.allowFileAccess = false
            webSetting.javaScriptCanOpenWindowsAutomatically = true
            webSetting.javaScriptEnabled = true
            webSetting.minimumFontSize = 12
            //解决有时候不可点击问题
            webSetting.domStorageEnabled = true
            // 设置自适应屏幕
            webSetting.loadWithOverviewMode = true
            webSetting.useWideViewPort = true
        }
        val verName = AppInfoUtil.getVerName(applicationContext)
        webSetting.userAgentString = webSetting.userAgentString + ("; " + StrsContents.PLUGIN_USER_AGENT + "/" + verName)
        webSetting.userAgentString = webSetting.userAgentString + ("; " + StrsContents.PLUGIN + "/" + StrsContents.PLUGIN_VERSION)
        webView.isHorizontalFadingEdgeEnabled = true
        webView.isVerticalScrollBarEnabled = false
        webView.isHorizontalScrollBarEnabled = false
        webView.isHorizontalScrollBarEnabled = true
        webView.scrollBarStyle = View.SCROLLBARS_OUTSIDE_OVERLAY

        try {
            webView.removeJavascriptInterface("searchBoxJavaBridge_")
            webView.removeJavascriptInterface("accessibility")
            webView.removeJavascriptInterface("accessibilityTraversal")
        } catch (e: Exception) {}
        webView.requestFocus()
        webView.webViewClient = object : WebViewClient(){
            override fun shouldOverrideUrlLoading(view: WebView?, url: String?): Boolean {
                LogUtils.d("payment web overriding $url")
                if (TextUtils.isEmpty(url)) return false
                if(url!!.contains(returnUrl)){
                    listener?.onResult(true)
                    finish()
                    return true
                }else if (url.contains("path=error")){
                    listener?.onResult(false)
                    finish()
                    return true
                }
                return super.shouldOverrideUrlLoading(view, url)
            }

            override fun onPageFinished(view: WebView?, url: String?) {
                if (webView.canGoBack()){
                    closeBtn.visibility = View.VISIBLE
                }else{
                    closeBtn.visibility = View.GONE
                }
                super.onPageFinished(view, url)
            }
        }
    }
}