package com.suning.mobile.epa.paymentcode.network

import android.util.Log
import com.suning.mobile.epa.kits.common.Environment_Config

object PaymentNetworkConfig {

    const val SUCCESS = "0000"

    private const val sitWapPayUrl = "https://wpaysit.cnsuning.com/epps-pwg/showCashierByToken.htm"
    private const val preWapPayUrl = "https://wpaypre.cnsuning.com/epps-pwg/showCashierByToken.htm"
    private const val prdWapPayUrl = "https://wpay.suning.com/epps-pwg/showCashierByToken.htm"
    private const val prexgWapPayUrl = "https://wpayprexg.cnsuning.com/epps-pwg/showCashierByToken.htm"
//    private const val sitWapPayUrl = "http://wpaysit.cnsuning.com/epps-pwg/routeGateway/merchant/paymentOrder.htm"
//    private const val preWapPayUrl = "https://wpaypre.cnsuning.com/epps-pwg/wapStandardCashier/showCashierByToken.htm"
//    private const val prdWapPayUrl = "https://wpay.suning.com/epps-pwg/routeGateway/merchant/paymentOrder.htm"
//    private const val prexgWapPayUrl = "https://wpayprexg.cnsuning.com/epps-pwg/routeGateway/merchant/paymentOrder.htm"


    var helpCenterUrl = Environment_Config.getInstance().helpCenterUrl + "chnCd=all&sndCatCd="

    val ftisUrl = Environment_Config.getInstance().ftisUrl

    val ftis2TradeUrl = Environment_Config.getInstance().getFTIS2Url(true, Environment_Config.FTIS2ServerName.trade)

    val ftis2BasicUrl = Environment_Config.getInstance().getFTIS2Url(true, Environment_Config.FTIS2ServerName.basic)

    var wapPayUrl = ""

    val loadSnjrUrl = "https://respay.suning.com/eppClientApp/html/mobile/index.html"

    init {
        when (Environment_Config.mNetType) {
            Environment_Config.NetType.PREXG -> {
                wapPayUrl = prexgWapPayUrl
                Log.d("wapPayUrl", "PREXG==>$wapPayUrl")
            }
            Environment_Config.NetType.PRE -> {
                wapPayUrl = preWapPayUrl
                Log.d("wapPayUrl", "PRE==>$wapPayUrl")
            }
            Environment_Config.NetType.PREJB -> {
                wapPayUrl = preWapPayUrl
                Log.d("wapPayUrl", "PREJB==>$wapPayUrl")
            }
            Environment_Config.NetType.PRD -> {
                wapPayUrl = prdWapPayUrl
                Log.d("wapPayUrl", "PRD==>$wapPayUrl")
            }
            Environment_Config.NetType.SIT -> {
                wapPayUrl = sitWapPayUrl
                Log.d("wapPayUrl", "SIT==>$wapPayUrl")
            }
            else -> {
                wapPayUrl = ""
                Log.d("wapPayUrl", "null==>$wapPayUrl")
            }
        }
    }

}
