package com.suning.mobile.epa.paymentcode.open

import com.android.volley.Response
import com.suning.mobile.epa.NetworkKits.net.VolleyErrorHelper
import com.suning.mobile.epa.NetworkKits.net.VolleyRequestController
import com.suning.mobile.epa.NetworkKits.net.basic.EpaEncrypt
import com.suning.mobile.epa.kits.utils.RiskTokenUtil
import com.suning.mobile.epa.paymentcode.network.PaymentNetworkConfig
import com.suning.mobile.epa.paymentcode.network.PaymentNetworkRequest
import org.json.JSONObject
import java.net.URLEncoder

    private const val TAG = "PaymentCodeOpenPresenter"

    fun sendQuerySimplePwdStatus(callBack : (Boolean, String, Boolean) -> Unit) {
        val url = PaymentNetworkConfig.ftis2TradeUrl + "payment/querySimplepwdStatus";
        val request = PaymentNetworkRequest(url,
                Response.Listener {
                    if (PaymentNetworkConfig.SUCCESS == it.responseCode) {
                        val resp = it.result.optJSONObject("respMsg")
                        val status = resp.optString("status")
                        val isLock = resp.optBoolean("isLock")
                        callBack(true, status, isLock)
                    } else {
                        callBack(false, it.responseMsg, false)
                    }
                },
                Response.ErrorListener {
                    callBack(false, VolleyErrorHelper.getMessage(it), false)
                })
        VolleyRequestController.getInstance().addToRequestQueueWithoutCache(request, TAG)
    }


    fun sendPaymentPwd(
            isSpwd: Boolean,
            pwd: String,
            callBack: (Boolean, JSONObject?, String) -> Unit) {
        val json = JSONObject()
        json.put("pwdType", if(isSpwd) "1" else "0")
        json.put("state", "1")
        if (isSpwd) {
            json.put("passWord", EpaEncrypt.getMD5Str(pwd))
        } else {
            json.put("passWord", pwd)
        }

        json.put("needUpdateAuthdata", "0")
        json.put("scene", "payqrcode")
        json.put("action", "open")
        json.put("appToken", RiskTokenUtil.getInstance().token)
        json.put("businessType", "newDevOpenQRCode")
        val data = EpaEncrypt.pbeLocalEncrypt(json.toString())
        val url = PaymentNetworkConfig.ftis2BasicUrl + "paymentPwd/verifyPaymentPwd.do?service=validatePayPwd" + "&data=" + URLEncoder.encode(data, "UTF-8")
        val request = PaymentNetworkRequest(url,
                Response.Listener {
                    if (PaymentNetworkConfig.SUCCESS == it.responseCode) {
                        callBack(true, it.result, "")
                    } else {
                        callBack(false, null, it.responseMsg)
                    }
                },
                Response.ErrorListener {
                    callBack(false, null, VolleyErrorHelper.getMessage(it))
                })
        VolleyRequestController.getInstance().addToRequestQueueWithoutCache(request, TAG)
    }
