package com.suning.mobile.epa.paymentcode.open

import android.content.Intent
import android.support.v4.app.FragmentActivity
import com.suning.mobile.epa.exchangerandomnum.ExchangeRmdNumUtil
import com.suning.mobile.epa.kits.utils.ActivityLifeCycleUtil
import com.suning.mobile.epa.kits.utils.ToastUtil
import com.suning.mobile.epa.kits.view.ProgressViewDialog
import com.suning.mobile.epa.paypwdinputview.NormalPwdDialogFragment
import com.suning.mobile.epa.paypwdinputview.SimplePwdDialogFragment

/**
 * @author zhongchi
 * @date 2019/1/4 16:58
 */
object PaymentCodeOpenUtil {

    fun startOpen(activity: FragmentActivity, openFace : Boolean, callBack : (Boolean, String) -> Unit){
        sendQueryPwdStatus(activity, openFace, callBack)
    }

    private fun sendQueryPwdStatus(activity: FragmentActivity, openFace : Boolean, callBack : (Boolean, String) -> Unit) {
        ProgressViewDialog.getInstance().showProgressDialog(activity)
        ProgressViewDialog.getInstance().setCannotDissmis()
        sendQuerySimplePwdStatus{isSuccess, status, isLock ->
            if (!ActivityLifeCycleUtil.isActivityDestory(activity)) {
                ProgressViewDialog.getInstance().dismissProgressDialog()
                if (isSuccess) {
                    ExchangeRmdNumUtil.getUser().simplepwdStatus = status
                    ExchangeRmdNumUtil.getUser().isSimplepwdLock = isLock
                    showPwdChecker(activity, "1" == status, openFace, callBack)
                }else{
                    callBack(false, status)
                }
            }
        }
    }


    private fun showPwdChecker(activity: FragmentActivity, isSimple: Boolean, openFace : Boolean, callBack : (Boolean, String) -> Unit) {
        if (isSimple) {
            SimplePwdDialogFragment.getInstance().showDialog(activity.fragmentManager,
                    {
                        SimplePwdDialogFragment.getInstance().dismissDialog()
                        callBack(false, "")
                    },
                    {
                        SimplePwdDialogFragment.getInstance().dismissDialog()
                        setPayment(activity, true, it, openFace, callBack)
                    },
                    {
                        SimplePwdDialogFragment.getInstance().dismissDialog()
                        findPayPwd(activity, openFace, callBack)
                    })
        } else {
            NormalPwdDialogFragment.getInstance().showDialog(activity.fragmentManager,
                    {
                        NormalPwdDialogFragment.getInstance().dismissDialog()
                        callBack(false, "")
                    },
                    {
                        NormalPwdDialogFragment.getInstance().dismissDialog()
                        setPayment(activity, false, it, openFace, callBack)
                    },
                    {
                        NormalPwdDialogFragment.getInstance().dismissDialog()
                        findPayPwd(activity, openFace, callBack)
                    })
        }
    }

    private fun findPayPwd(activity : FragmentActivity, openFace : Boolean, callBack : (Boolean, String) -> Unit) {
        val user = ExchangeRmdNumUtil.getUser()
//        PaymentCodePayPwdUtil.setPayPwd(activity, object : PaymentCodePayPwdUtil.SetPayPwdCallBack {
//            override fun onResult(isSuccess : Boolean, msg : String) {
//                if (isSuccess) {
//                    user.simplepwdStatus = "1"
//                    sendQueryPwdStatus(activity, openFace, callBack)
//                }else{
//                    callBack(false, msg)
//                }
//            }
//        })
    }

    private fun setPayment(activity: FragmentActivity,
                           isSpwd: Boolean,
                           pwd: String,
                           openFace : Boolean,
                           callBack : (Boolean, String) -> Unit) {
        ProgressViewDialog.getInstance().showProgressDialog(activity)
        ProgressViewDialog.getInstance().setCannotDissmis()
        sendPaymentPwd(isSpwd, pwd) { isSuccess, data, msg ->
            if (!ActivityLifeCycleUtil.isActivityDestory(activity)){
                ProgressViewDialog.getInstance().dismissProgressDialog()
                if (isSuccess) {
                    PaymentSMSVerifyActivity.listener = object  : PaymentSMSVerifyActivity.PaymentSMSVerifyListener{
                        override fun onResult(isSuccess: Boolean) {
                            if (isSuccess){
                                callBack(true, "")
                            }else{
                                callBack(false, "")
                            }
                        }
                    }
                    if (openFace) {
                        data?.put("faceToFacePay", "10")
                    }
                    val intent = Intent(activity, PaymentSMSVerifyActivity::class.java)
                    intent.putExtra("result", data?.toString())
                    activity.startActivity(intent)
                }else{
                    ToastUtil.showMessage(msg)
                    sendQueryPwdStatus(activity, openFace, callBack)
                }
            }
        }
    }
}