package com.suning.mobile.epa.paymentcode.open

import android.animation.Animator
import android.animation.AnimatorListenerAdapter
import android.animation.ValueAnimator
import android.app.Activity
import android.os.Bundle
import android.text.Editable
import android.text.Html
import android.text.TextWatcher
import android.view.animation.LinearInterpolator
import android.widget.TextView
import com.suning.epafusion.R
import com.suning.mobile.epa.exchangerandomnum.ExchangeRmdNumUtil
import com.suning.mobile.epa.kits.utils.ActivityLifeCycleUtil
import com.suning.mobile.epa.kits.utils.ToastUtil
import com.suning.mobile.epa.kits.view.ProgressViewDialog
import com.suning.mobile.epa.paymentcode.PaymentCodeGlobalInfo
import com.suning.mobile.epa.paymentcode.network.PaymentNetworkConfig
import com.suning.mobile.epa.paymentcode.utils.PaymentCodeSPUtil
import kotlinx.android.synthetic.main.activity_payment_sms_verify.*
import kotlinx.android.synthetic.main.payment_activity_title.*
import org.json.JSONObject


class PaymentSMSVerifyActivity : Activity(){

    private val SCENE_ID = "FTIS-M-021"

    private lateinit var jsonObject: JSONObject;

    interface PaymentSMSVerifyListener{
        fun onResult(isSuccess : Boolean)
    }

    companion object {
        var listener : PaymentSMSVerifyListener? = null
    }

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_payment_sms_verify)
        initData();
        initTitle()
        verifySms.setOnClickListener { verifySmsCode() }
        getSms.setOnClickListener {
            sendSms();
        }
        setPhoneNum();
        getSms.performClick();
        smsCode.addTextChangedListener(object : TextWatcher {
            override fun beforeTextChanged(s: CharSequence, start: Int, count: Int, after: Int) {

            }

            override fun onTextChanged(s: CharSequence, start: Int, before: Int, count: Int) {

            }

            override fun afterTextChanged(s: Editable) {
                verifySms.isEnabled = s.length >= 6
            }
        })

        notReceiveSms.setOnClickListener {
            val url = PaymentNetworkConfig.helpCenterUrl + "yzm_qbwt";
            PaymentCodeGlobalInfo.h5CallBack?.gotoH5WebVIew(this@PaymentSMSVerifyActivity, url)
        }
    }

    private fun setPhoneNum() {
        var html = "<font color='#666666'>" + "+86  " + "</font>"
        html += "<font color='#170000'>" + ExchangeRmdNumUtil.getUser().bindMobile.subSequence(0, 3) + " **** **" + ExchangeRmdNumUtil.getUser().bindMobile.subSequence(9, 11) + "<font>"
        val charSequence = Html.fromHtml(html)
        phoneNum.text = charSequence
    }

    private fun verifySmsCode() {
        jsonObject.put("sceneId", SCENE_ID)
        jsonObject.put("smsCode", smsCode.text.toString())
        verifySms(jsonObject){isSuccess, msg ->
            if (!ActivityLifeCycleUtil.isActivityDestory(this)) {
                ProgressViewDialog.getInstance().dismissProgressDialog()
                if (isSuccess){
                    listener?.onResult(true)
                    finish()
                }else{
                    ToastUtil.showMessage(msg)
                }
            }
        }
    }

    private fun initData() {
        jsonObject = JSONObject(intent.getStringExtra("result"))
    }

    private fun sendSms() {
        val valueAnimator = ValueAnimator.ofInt(59, 0)
        valueAnimator.duration = (59 * 1000).toLong()
        valueAnimator.addUpdateListener { animation ->
            getSms.text = animation.animatedValue.toString() + "S"
        }
        valueAnimator.interpolator = LinearInterpolator()
        valueAnimator.addListener(object : AnimatorListenerAdapter() {

            override fun onAnimationEnd(animation: Animator) {
                super.onAnimationEnd(animation)
                getSms.isClickable = true;
                getSms.text = "重新获取"
            }

            override fun onAnimationStart(animation: Animator) {
                super.onAnimationStart(animation)
                getSms.isClickable = false;
            }
        })
        valueAnimator.start()
        ProgressViewDialog.getInstance().showProgressDialog(this);
        sendSms(SCENE_ID){isSuccess, msg ->
            ProgressViewDialog.getInstance().dismissProgressDialog()
            if (!ActivityLifeCycleUtil.isActivityDestory(this)) {
                if (isSuccess) {
                    ToastUtil.showMessage("验证码发送成功，请注意查收")
                } else {
                    ToastUtil.showMessage(msg)
                }
            }
        }
    }


    private fun initTitle() {
        titleText.text = "验证手机号"
        backBtn.setOnClickListener {
            onBackPressed()
        }
    }

    override fun onBackPressed() {
        listener?.onResult(false)
        super.onBackPressed()
    }
}
