package com.suning.mobile.epa.paymentcode.open

import com.android.volley.Response
import com.suning.mobile.epa.NetworkKits.net.VolleyErrorHelper
import com.suning.mobile.epa.NetworkKits.net.VolleyRequestController
import com.suning.mobile.epa.NetworkKits.net.basic.EpaEncrypt
import com.suning.mobile.epa.paymentcode.network.PaymentNetworkConfig
import com.suning.mobile.epa.paymentcode.network.PaymentNetworkRequest
import org.json.JSONObject
import java.net.URLEncoder

    private const val TAG = "PaynebtSMSVerifyPresenter"
    fun verifySms(json: JSONObject, callBack : (Boolean, String) -> Unit) {

        val data = EpaEncrypt.pbeLocalEncrypt(json.toString())
        val url = PaymentNetworkConfig.ftis2TradeUrl + "paymentPassWord/validateSmsCode.do?data=" + URLEncoder.encode(data, "UTF-8")
        val request = PaymentNetworkRequest(url,
                Response.Listener {
                    if (PaymentNetworkConfig.SUCCESS == it.responseCode) {
                        callBack(true, "")
                    } else {
                        callBack(false, it.responseMsg)
                    }
                },
                Response.ErrorListener {
                    callBack(false, VolleyErrorHelper.getMessage(it))
                })
        VolleyRequestController.getInstance().addToRequestQueueWithoutCache(request, TAG)
    }

    fun sendSms(sceneId: String, callBack : (Boolean, String) -> Unit) {
        val json = JSONObject()
        json.put("sceneId", sceneId)
        val data = EpaEncrypt.pbeLocalEncrypt(json.toString())
        val url = PaymentNetworkConfig.ftis2TradeUrl + "paymentPassWord/sendSmsCode.do?data=" + URLEncoder.encode(data, "UTF-8")
        val request = PaymentNetworkRequest(url,
                Response.Listener {
                    if (PaymentNetworkConfig.SUCCESS == it.responseCode) {
                        callBack(true, "")
                    } else {
                        callBack(false, it.responseMsg)
                    }
                },
                Response.ErrorListener {
                    callBack(false, VolleyErrorHelper.getMessage(it))
                })
        VolleyRequestController.getInstance().addToRequestQueueWithoutCache(request, TAG)
    }