package com.suning.mobile.epa.paymentcode.utils

import android.content.Context
import android.os.Build
import android.text.TextUtils
import android.util.Log
import android.webkit.CookieManager
import android.webkit.CookieSyncManager
import com.suning.mobile.epa.NetworkKits.net.VolleyRequestController
import com.suning.mobile.epa.paymentcode.network.PaymentNetworkConfig
import org.apache.http.cookie.Cookie


object CookieUtils {
    fun syncCookie(url: String,context: Context) {
        if (Build.VERSION.SDK_INT < Build.VERSION_CODES.LOLLIPOP) {
            CookieSyncManager.createInstance(context)
        }
        val cookieManager = CookieManager.getInstance()
        cookieManager.setAcceptCookie(true)
        cookieManager.removeAllCookie()
        val sb = StringBuffer()
        val cookieStore = VolleyRequestController.getInstance().cookieStore ?: return
        val cookies = cookieStore.cookies
        for (cookie in cookies) {
            val cookieName = cookie.getName()
            val cookieValue = cookie.getValue()
            if (!TextUtils.isEmpty(cookieName) && !TextUtils.isEmpty(cookieValue)) {
                sb.append(cookieName + "=")
                sb.append(cookieValue + ";")
            }
        }


        val cookie = sb.toString().split(";".toRegex()).dropLastWhile { it.isEmpty() }.toTypedArray()
        for (i in cookie.indices) {
            Log.i("cookie11", "cookie:" + cookie[i])
            cookieManager.setCookie(PaymentNetworkConfig.wapPayUrl, cookie[i])// cookies是在HttpClient中获得的cookie
        }
        CookieSyncManager.getInstance().sync()
    }
}