package com.suning.mobile.epa.paymentcode.utils

import android.content.Context
import com.suning.mobile.epa.kits.EpaKitsApplication

object PaymentCodeSPUtil {

    private const val COMMON = "common"

    //同步付款码的时间差
    private const val QR_PAYMENT_CODE_DELTA_T = "delta_T"



    private val mSP = EpaKitsApplication.getInstance().getSharedPreferences(COMMON, Context.MODE_PRIVATE)

    private fun setValue(key: String, value: Any) {
        if (mSP != null) {
            val editor = mSP.edit()
            when (value) {
                is String -> editor.putString(key, value)
                is Boolean -> editor.putBoolean(key, value)
                is Long -> editor.putLong(key, value)
                is Int -> editor.putInt(key, value)
                is Float -> editor.putFloat(key, value)
            }
            editor.apply()
        }
    }

    //保存网络时间差
    fun saveNetworkDeltaTime(time: Long) {
        setValue(QR_PAYMENT_CODE_DELTA_T, time)
    }

    //读取网络时间差
    fun getNetworkDeltaTime(): Long {
        return mSP.getLong(QR_PAYMENT_CODE_DELTA_T, 0L)
    }
}