package com.suning.mobile.epa.paymentcode.utils

import android.os.SystemClock
import com.suning.mobile.epa.kits.utils.LogUtils

import java.text.SimpleDateFormat
import java.util.*

/**
 * Created by 15110020 on 2016/11/28.
 */

object PaymentCodeTimeSyncUtils {

    private var dateFmYMDHMS = SimpleDateFormat("yyyyMMddHHmmss", Locale.CHINESE)

    var timeResponse = 0L
    private var elapsedRealtime: Long = 0

    fun setTimeFromResponse(cacheDate: Long) {
        timeResponse = cacheDate
        elapsedRealtime = SystemClock.elapsedRealtime()
    }

    fun getPaymentCodeCurrentTime(): String {
        val currentElapsedRealTime = SystemClock.elapsedRealtime()
        var date = Date(timeResponse * 1000 + (currentElapsedRealTime - elapsedRealtime))
        if (0L == timeResponse) {
            val daltaT = PaymentCodeSPUtil.getNetworkDeltaTime()
            val currentRealTime = System.currentTimeMillis() - daltaT
            date = Date(currentRealTime)
        }
        return formatDateToChineseTimeZone(dateFmYMDHMS, date)
    }

    /**
     * 将Date转化为中国时区的字符串
     * @param dateFormat 时间格式
     * @param date 时间
     * @return
     */
    @Synchronized
    fun formatDateToChineseTimeZone(dateFormat: SimpleDateFormat?, date: Date?): String {
        if (dateFormat == null || date == null) {
            return ""
        }
        val timeZone = dateFormat.timeZone
        val chineseTimeZone = TimeZone.getTimeZone("GMT+8")
        //强制设置为服务器所在时区（中国时区）
        dateFormat.timeZone = chineseTimeZone
        var dateStr: String
        try {
            dateStr = dateFormat.format(date)
        } catch (e: Exception) {
            dateStr = ""
            LogUtils.logException(e)
        }

        //重新设置为原始时区
        dateFormat.timeZone = timeZone
        LogUtils.i("dateStr", dateStr)
        return dateStr
    }
}
