package com.suning.mobile.epa.paymentcode.utils

import java.text.ParseException
import java.text.SimpleDateFormat
import java.util.*

/**
 * @author 18031780
 */
object PaymentDateUtil {

    /**
     * 比较两个日期的大小，日期格式为yyyy-MM-dd
     *
     * @param str1 the first date
     * @param str2 the second date
     * @return true <br></br>false
     */
    fun isDateOneBigger(str1: String, str2: String): Boolean {
        val sdf = SimpleDateFormat("yyyy-MM-dd HH:mm:ss", Locale.CHINESE)
        val sdf1 = SimpleDateFormat("yyyyMMddHHmmss", Locale.CHINESE)
        var dt1: Date? = null
        var dt2: Date? = null
        try {
            dt1 = sdf.parse(str1)
            dt2 = sdf1.parse(str2)
        } catch (e: ParseException) {
            e.printStackTrace()
        }

        if (dt1 == null || dt2 == null){
            return false
        }else{
            return dt1.time > dt2.time
        }
    }

    /**
     * 比较两个日期相差的毫秒数
     *
     * @param str1 the first date
     * @param str2 the second date
     * @return true <br></br>false
     */
    fun dateGap(str1: String, str2: String): Long {
        val sdf = SimpleDateFormat("yyyy-MM-dd HH:mm:ss", Locale.CHINESE)
        val sdf1 = SimpleDateFormat("yyyyMMddHHmmss", Locale.CHINESE)
        var dt1: Date? = null
        var dt2: Date? = null
        try {
            dt1 = sdf.parse(str1)
            dt2 = sdf1.parse(str2)
        } catch (e: ParseException) {
            e.printStackTrace()
        }
        if (dt1 == null || dt2 == null){
            return Long.MAX_VALUE
        }

        return dt1.time - dt2.time
    }
}
