package com.suning.epafusion

import android.app.Application
import android.content.Context
import android.content.Intent
import com.suning.epafusion.h5.PaymentCodeH5Activity
import com.suning.epafusion.payment.EpaFusionContainerFragment
import com.suning.epafusion.payment.PaymentGlobalInfo
import com.suning.mobile.epa.NetworkKits.net.NetKitApplication
import com.suning.mobile.epa.kits.EpaKitsApplication
import com.suning.mobile.epa.kits.common.Environment_Config
import com.suning.mobile.epa.kits.common.SourceConfig
import com.suning.mobile.epa.kits.utils.LogUtils
import com.suning.mobile.epa.paymentcode.PaymentCodeBuilder
import com.suning.sastatistics.StatisticsProcessor
import com.suning.statistics.CloudytraceStatisticsProcessor

/**
 * @author zhongchi
 * @date 2019/1/3 14:43
 */
class EpaFusionProxyForPaycode {
    companion object {
        /**
         * 初始化方法
         *
         * @param application
         */
        fun initSdk(app : Application){
            EpaKitsApplication.setContext(app)
            NetKitApplication.getInstance().setContext(app)
            Environment_Config.initNetWord(Environment_Config.NetType.PRD)
            //不是生产环境，打开日志
            if(!Environment_Config.getInstance().isPrd) {
                LogUtils.DEBUG = true
            }
            PaymentCodeBuilder.builder
                    .setChannel(PaymentGlobalInfo.channel)
                    .setSource(SourceConfig.SourceType.SN_ANDROID)
                    .setVersion(BuildConfig.PLUGIN_VERSION)
                    .setH5CallBack(object : PaymentCodeBuilder.PaymentH5CallBack{
                        override fun gotoH5WebVIew(context: Context, url: String) {
                            val intent = Intent(context, PaymentCodeH5Activity::class.java)
                            intent.putExtra("url", url)
                            context.startActivity(intent)
                        }
                    }).setErrorViewCallBack(object : PaymentCodeBuilder.PaymentShowErrorView{
                        override fun showErrorView() {
                            EpaFusionContainerFragment.INSTANCE?.showErrorView()
                        }
                    })
            CloudytraceStatisticsProcessor.setAppKey("060e50a9e2e04cd4822a0008848caa29").enableDebug(true).start(app)
            StatisticsProcessor.init().setAppKey("InspurWDNJ").enableDebug(true).start(app)
        }
    }
}