package com.suning.epafusion.h5

import android.app.Activity
import android.os.Bundle
import android.text.TextUtils
import android.webkit.WebView
import com.suning.epafusion.base.EPAPluginH5BaseActivity
import com.suning.epafusion.utils.WebViewCookieUtils
import com.suning.epafusion.utils.syncLocalCookie

/**
 * @author zhongchi
 * @date 2019/1/21 11:13
 */
class PaymentCodeH5Activity : EPAPluginH5BaseActivity() {

    private var mUrl = ""
    private var backUrl = ""

    override fun onCreate(savedInstanceState: Bundle?) {
        mUrl = intent.getStringExtra("url") ?: ""
        backUrl = intent.getStringExtra("backUrl") ?: ""
        super.onCreate(savedInstanceState)
    }
    override fun getUrl(): String {
        return mUrl
    }

    override fun firstLoadUrl() {
        WebViewCookieUtils.syncCookie(this, mUrl)
        webView.loadUrl(mUrl)
    }

    override fun onOverrideUrlLoading(view: WebView?, url: String?): Boolean {
        if (!TextUtils.isEmpty(backUrl) && url?.startsWith(backUrl) == true){
            setResult(Activity.RESULT_OK)
            syncLocalCookie()
            finish()
        }else {
            webView.loadUrl(url)
        }
        return true
    }

    override fun onPageFinishedInvoked() {
        super.onPageFinishedInvoked()
        if (!TextUtils.isEmpty(titleBar.stringTitle) && titleBar.stringTitle.length >= 12) {
            val temp = titleBar.stringTitle
            titleBar.setTitleText(temp.substring(0, 12) + "..")
        }
    }
}