package com.suning.epafusion.payment

import android.Manifest
import android.app.Activity
import android.os.Bundle
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import com.suning.epafusion.R
import com.suning.mobile.epa.exchangerandomnum.ExchangeRmdNumUtil
import com.suning.mobile.epa.kits.utils.ToastUtil
import com.suning.mobile.epa.paymentcode.main.PaymentCodeMainFragment
import kotlinx.android.synthetic.main.epafusion_container_fragment.*
import android.content.Intent
import android.content.pm.PackageManager
import android.net.Uri
import android.support.v4.app.ActivityCompat
import android.support.v4.app.Fragment
import android.text.Spannable
import android.text.SpannableString
import android.text.TextPaint
import android.text.TextUtils
import android.text.method.LinkMovementMethod
import android.text.style.ClickableSpan
import android.view.animation.AnimationUtils
import android.view.animation.LinearInterpolator
//import com.suning.epa.logonrisk.LRAuthenticateProxy
import com.suning.epafusion.h5.PaymentCodeH5Activity
import com.suning.epafusion.net.PaymentEnviromentConfig
import com.suning.epafusion.utils.clearLocalCookie
import com.suning.mobile.epa.NetworkKits.net.basic.EpaEncrypt
import com.suning.mobile.epa.kits.utils.ActivityLifeCycleUtil
import com.suning.mobile.epa.kits.utils.LogUtils
import com.suning.mobile.epa.kits.view.CustomAlertDialog
import com.suning.mobile.epa.statistic.CustomStatisticsProxy
import org.json.JSONObject
import java.net.URLEncoder
import java.util.HashMap

/**
 * @author zhongchi
 * @date 2019/1/3 15:03
 */
class EpaFusionContainerFragment : Fragment() {

    private val REQUEST_AUTH = 200
    private val REQUEST_CALL = 300
    private val REQUEST_LOGIN = 400
    private val REQUEST_PRIMARY = 500
    private val REQUEST_DEVICE = 600
    private var accessToken = ""
    private var accessCode = ""
    private var phoneNo = ""
    private var smsLoginTicket = ""
    private var idCardLoginTicket = ""

    private var paymentFragment : PaymentCodeMainFragment? = null

    private var isLoging = false

    companion object {
        var INSTANCE : EpaFusionContainerFragment? = null
    }

    override fun onCreateView(inflater: LayoutInflater, container: ViewGroup?, savedInstanceState: Bundle?): View? {
        return inflater.inflate(R.layout.epafusion_container_fragment, null, false)
    }

    override fun onViewCreated(view: View, savedInstanceState: Bundle?) {
        super.onViewCreated(view, savedInstanceState)
        INSTANCE = this
        initView()
        initData()
    }

    override fun onResume() {
        super.onResume()
        if (open.visibility == View.VISIBLE) {
            open.isClickable = true
        }
    }

    override fun onDetach() {
        super.onDetach()
        INSTANCE = null
    }

    private fun initView(){
        startAnim()
        val spt = SpannableString("信息获取失败，请重试或联系客服95177")
        spt.setSpan(object : ClickableSpan(){
            override fun onClick(widget: View?) {
                showTelDialog()
            }

            override fun updateDrawState(ds: TextPaint?) {
                super.updateDrawState(ds)
                ds?.color = resources.getColor(R.color.color247CF0)
                ds?.isUnderlineText = false
                ds?.clearShadowLayer()
            }
        }, spt.length -5, spt.length, Spannable.SPAN_EXCLUSIVE_EXCLUSIVE)
        errorText.text = spt
        errorText.movementMethod = LinkMovementMethod.getInstance()
        errorText.highlightColor = resources.getColor(android.R.color.transparent)

        refresh.setOnClickListener {
            startAnim()
            initData()
            statisticsClick("MynjSX")
        }

        open.setOnClickListener {
            val user = ExchangeRmdNumUtil.getUser()
            if (user.accountNo != null && !user.isAuthStatus) {
                startPrimaryH5()
            }else if (!TextUtils.isEmpty(smsLoginTicket)) {
//                startRiskLogin(true)
            }else if (!TextUtils.isEmpty(idCardLoginTicket)){
//                startRiskLogin(false)
            }else if (!TextUtils.isEmpty(accessCode)){
                startLoginH5()
            }
            open.isClickable = false
            statisticsClick("MynjQKT")
        }
    }

    private fun initData() {
        clearLocalCookie()
        ExchangeRmdNumUtil.clearUser()
        val intent = Intent()
        LogUtils.i("EpaFusionContainerFragment","initData")
        intent.action = "com.zjsyinfo.auth"
        intent.putExtra("appId", "snjr")
        startActivityForResult(intent, REQUEST_AUTH)
    }
    private fun loginByToken(){
        if (ActivityCompat.checkSelfPermission(activity!!,Manifest.permission.READ_PHONE_STATE) == PackageManager.PERMISSION_GRANTED) {
            loginByToken(accessToken) {data ->
                if (!ActivityLifeCycleUtil.isFragmentDestory(activity, this@EpaFusionContainerFragment)) {
                    if(data != null){
                        LogUtils.i("EpaFusionContainerFragment","data:"+data.result.toString())
                    }
                    when (data?.responseCode) {
                        "0000" -> {
                            ExchangeRmdNumUtil.setUserInfo(data.result.getJSONObject("responseData"))
                            val user = ExchangeRmdNumUtil.getUser()
                            if (user != null && user.isAuthStatus) {
                                showPayment()
                            } else {
                                showOpenView()
                            }
                        }
                        "2114" -> {
                            showOpenView()
                            accessCode = data.result.optString("accessCode")
                            smsLoginTicket = ""
                            idCardLoginTicket = ""
                            phoneNo = data.result.optString("phoneNo")
                        }

                        "LC00010" -> {
                            showOpenView()
                            accessCode = ""
                            smsLoginTicket = data.result.optString("smsLoginTicket")
                            idCardLoginTicket = ""
                            phoneNo = data.result.optString("maskBindPhone")
                        }
                        "LC00011" -> {
                            showOpenView()
                            accessCode = ""
                            smsLoginTicket = ""
                            idCardLoginTicket = data.result.optString("idCardLoginTicket")
                            phoneNo = ""
                        }
                        else -> {
                            showErrorView()
                            accessCode = ""
                            smsLoginTicket = ""
                            idCardLoginTicket = ""
                            phoneNo = ""
                        }
                    }
                }
            }
        }else{
            requestPermissions(arrayOf(Manifest.permission.READ_PHONE_STATE), REQUEST_DEVICE)
        }
    }

    private fun loginByCode(){
        if (!isLoging) {
            isLoging = true
            loginByCode(accessCode) { data ->
                if (!ActivityLifeCycleUtil.isFragmentDestory(
                        activity,
                        this@EpaFusionContainerFragment
                    )
                ) {
                    isLoging = false
                    if ("0000" == data?.responseCode) {
                        ExchangeRmdNumUtil.setUserInfo(data.result)
                        val user = ExchangeRmdNumUtil.getUser()
                        if (user != null && user.isAuthStatus) {
                            showPayment()
                        } else {
                            accessCode = ""
                            startPrimaryH5()
                        }
                    } else {
                        accessCode = ""
                        ToastUtil.showMessage(data?.responseMsg)
                        showErrorView()
                    }
                }
            }
        }
    }

    private fun addChildFragment(){
        if (paymentFragment == null){
            paymentFragment = PaymentCodeMainFragment()
        }
        val transaction = childFragmentManager.beginTransaction()
        transaction.replace(R.id.container, paymentFragment)
        transaction.commitAllowingStateLoss()
        container.visibility = View.VISIBLE
    }
    private fun removeChildFragment(){
        if (paymentFragment != null) {
            val transaction = childFragmentManager.beginTransaction()
            transaction.remove(paymentFragment)
            transaction.commitAllowingStateLoss()
            container.visibility = View.GONE
        }
    }

    override fun onActivityResult(requestCode: Int, resultCode: Int, data: Intent?) {
        super.onActivityResult(requestCode, resultCode, data)
        LogUtils.i("EpaFusionContainerFragment","onActivityResult requestCode="+requestCode)
        when (requestCode){
            REQUEST_AUTH->{
                if (resultCode == Activity.RESULT_OK) {
                    val result = data?.getStringExtra("result")
                    try {
                        val json = JSONObject(result)
                        LogUtils.i("EpaFusionContainerFragment","onActivityResult json="+json.toString())
                        val isSuccess = json.optBoolean("success")
                        if (isSuccess) {
                            accessToken = json.optJSONObject("data").optString("accessToken")
                            loginByToken()
                        } else {
                            ToastUtil.showMessage(json.optString("msg"))
                            showErrorView()
                        }
                    } catch (e: Exception) {
                        LogUtils.d(e.printStackTrace().toString())
                    }
                }else{
                    showErrorView()
                }

            }
            REQUEST_LOGIN ->{
                if (resultCode == Activity.RESULT_OK){
                    loginByCode()
                }else{
                    initData()
                }
            }
            REQUEST_PRIMARY -> {
                if (resultCode == Activity.RESULT_OK){
                    showPayment()
                }else{
                    showOpenView()
                }
            }
            else ->{}
        }
    }

    override fun onRequestPermissionsResult(requestCode: Int, permissions: Array<out String>, grantResults: IntArray) {
        super.onRequestPermissionsResult(requestCode, permissions, grantResults)
        when (requestCode) {
            REQUEST_CALL -> {
                if (grantResults[0] == PackageManager.PERMISSION_GRANTED){
                    dial()
                }else{
                    ToastUtil.showMessage("请授权拨打电话后重试")
                }
            }
            REQUEST_DEVICE -> {
                if (grantResults[0] == PackageManager.PERMISSION_GRANTED){
                    loginByToken()
                }else{
                    showErrorView()
                    ToastUtil.showMessage("请授权获取手机信息后重试")
                }
            }
            else ->{}
        }
    }

    private fun startAnim(){
        fusionView.visibility = View.VISIBLE
        loadingLayout.visibility = View.VISIBLE
        errorContainer.visibility = View.GONE
        openContainer.visibility = View.GONE
        container.visibility = View.GONE
        val anim1 = AnimationUtils.loadAnimation(context, R.anim.epafusion_payment_loading)
        anim1.interpolator = LinearInterpolator()
        loading1.startAnimation(anim1)
        val anim2 = AnimationUtils.loadAnimation(context, R.anim.epafusion_payment_loading)
        anim2.interpolator = LinearInterpolator()
        loading2.startAnimation(anim2)
    }

    private fun stopAnim(){
        loading1.clearAnimation()
        loading2.clearAnimation()
    }

    fun showErrorView(){
        try {
            var e = NullPointerException()
            LogUtils.e("EpaFusionContainerFragment","showErrorView",e)
        }catch (e : NullPointerException){
            LogUtils.e("EpaFusionContainerFragment","showErrorView",e)
        }
        stopAnim()
        fusionView.visibility = View.VISIBLE
        loadingLayout.visibility = View.GONE
        errorContainer.visibility = View.VISIBLE
        openContainer.visibility = View.GONE
        removeChildFragment()
    }

    private fun showPayment(){
        stopAnim()
        fusionView.visibility = View.GONE
        loadingLayout.visibility = View.GONE
        errorContainer.visibility = View.GONE
        openContainer.visibility = View.GONE
        container.visibility = View.VISIBLE
        addChildFragment()
    }

    private fun showOpenView(){
        stopAnim()
        fusionView.visibility = View.VISIBLE
        loadingLayout.visibility = View.GONE
        errorContainer.visibility = View.GONE
        openContainer.visibility = View.VISIBLE
        removeChildFragment()
    }

    private fun showTelDialog(){
        CustomAlertDialog.showNoTitleRightBtn(activity!!.fragmentManager,
                "拨打苏宁客服：95177", "拨号",
                {
                    if (ActivityCompat.checkSelfPermission(activity!!,Manifest.permission.CALL_PHONE) == PackageManager.PERMISSION_GRANTED) {
                        dial()
                    }else{
                        requestPermissions(arrayOf(Manifest.permission.CALL_PHONE), REQUEST_CALL)
                    }
                }, true)
    }

    private fun dial(){
        val intentTel = Intent(Intent.ACTION_DIAL)
        intentTel.data = Uri.parse("tel:95177")
        startActivity(intentTel)
    }

    private fun startLoginH5(){
        val loginUrl = PaymentEnviromentConfig.loginUrl +
                "&service=${PaymentEnviromentConfig.backUrl}" +
                "&channelSource=${PaymentGlobalInfo.pasportSource}" +
                "&source=${PaymentGlobalInfo.primarySource}" +
                "&quickPhoneNo=$phoneNo"

        val intent = Intent(context, PaymentCodeH5Activity::class.java)
        LogUtils.d("loginUrl = $loginUrl")
        intent.putExtra("url", loginUrl)
        intent.putExtra("backUrl", PaymentEnviromentConfig.backUrl)
        startActivityForResult(intent, REQUEST_LOGIN)
    }

//    private fun startRiskLogin(isSms : Boolean){
//        LRAuthenticateProxy.authenticate(activity,
//                if (isSms)"002" else "001",
//                smsLoginTicket,
//                phoneNo,
//                "",
//                idCardLoginTicket,
//                object : LRAuthenticateProxy.AuthCallback{
//                    override fun onSuccess() {
//                        loginByCode()
//                    }
//
//                    override fun onFailure(code: String?, msg: String?) {
//                    }
//
//                    override fun onOpenUrl(url: String?) {
//                        if (!TextUtils.isEmpty(url)) {
//                            val intent = Intent(context, PaymentCodeH5Activity::class.java)
//                            intent.putExtra("url", url)
//                            startActivity(intent)
//                        }
//                    }
//                })
//    }

    private fun startPrimaryH5(){
        val primaryUrl = PaymentEnviromentConfig.primaryUrl +
                "backUrl=${URLEncoder.encode(PaymentEnviromentConfig.backUrl, "UTF-8")}" +
                "&source=${PaymentGlobalInfo.primarySource}"
        val intent = Intent(context, PaymentCodeH5Activity::class.java)
        intent.putExtra("url", primaryUrl)
        intent.putExtra("backUrl", PaymentEnviromentConfig.backUrl)
        startActivityForResult(intent, REQUEST_PRIMARY)
    }

    private fun statisticsClick(eleId : String){
        val eventDetail = HashMap<String, String>()
        eventDetail["pageId"] = "Mynj"
        eventDetail["eleId"] = eleId
        CustomStatisticsProxy.setClickEvent(eventDetail)
    }
}