package com.suning.epafusion.payment

import com.android.volley.Request
import com.android.volley.Response
import com.suning.epafusion.net.PaymentEnviromentConfig
import com.suning.mobile.epa.NetworkKits.net.NetworkBeanRequest
import com.suning.mobile.epa.NetworkKits.net.VolleyRequestController
import com.suning.mobile.epa.NetworkKits.net.basic.EpaEncrypt
import com.suning.mobile.epa.NetworkKits.net.basic.NetworkBean
import com.suning.mobile.epa.kits.EpaKitsApplication
import com.suning.mobile.epa.kits.common.Environment_Config
import com.suning.mobile.epa.kits.utils.DeviceInfoUtil
import com.suning.mobile.epa.kits.utils.LogUtils
import com.suning.mobile.epa.symencrypt.EPAEncryptProxy
import com.suning.mobile.epaencryption.RSAEncrypt
import org.json.JSONObject
import java.lang.Exception
import java.net.URLEncoder

/**
 * @author zhongchi
 * @date 2019/1/21 15:59
 */

private const val TAG = "PaymentLoginPresenter"

fun loginByToken(token : String, callBack : (NetworkBean?) -> Unit){

    val prd = EPAEncryptProxy.createRandomPass()
    EPAEncryptProxy.setRandomPass(prd)
    val json = JSONObject()
    try {
        json.put("accessToken", token)
        json.put("channelSource", PaymentGlobalInfo.pasportSource)
        json.put("clientMAC", DeviceInfoUtil.getMacAddress(EpaKitsApplication.getInstance()))
        json.put("deviceId", DeviceInfoUtil.getDeviceId(EpaKitsApplication.getInstance()))
    }catch (e : Exception){
        LogUtils.d(e.printStackTrace().toString())
    }
    val url = PaymentEnviromentConfig.ftis2BasicUrl + "openMerchants/queryBindingRelations.do?"
    var body = ""
    body += "rpd=" + URLEncoder.encode(RSAEncrypt.encryptByFTISPublicKey(prd, Environment_Config.getInstance().isPrd), "UTF-8")
    body += "&data=" + URLEncoder.encode(EpaEncrypt.pbeLocalEncrypt(json.toString()), "UTF-8")
    val request = NetworkBeanRequest(Request.Method.POST,
            url,
            body,
            Response.Listener {
                LogUtils.json(it.result.toString())
                callBack(it)
            },
            Response.ErrorListener {
                callBack(null)
            })
    VolleyRequestController.getInstance().addToRequestQueueWithoutCache(request, TAG)
}

fun loginByCode(code : String, callBack : (NetworkBean?) -> Unit){

    val prd = EPAEncryptProxy.createRandomPass()
    EPAEncryptProxy.setRandomPass(prd)
    val json = JSONObject()
    json.put("accessCode", code)
    val url = PaymentEnviromentConfig.ftis2BasicUrl + "openMerchants/accountBinding.do?"
    var body = ""
    body += "rpd=" + URLEncoder.encode(RSAEncrypt.encryptByFTISPublicKey(prd, Environment_Config.getInstance().isPrd), "UTF-8")
    body += "&data=" + URLEncoder.encode(EpaEncrypt.pbeLocalEncrypt(json.toString()), "UTF-8")

    val request = NetworkBeanRequest(Request.Method.POST,
            url,
            body,
            Response.Listener {
                LogUtils.json(it.result.toString())
                callBack(it)
            },
            Response.ErrorListener {
                callBack(null)
            })
    VolleyRequestController.getInstance().addToRequestQueueWithoutCache(request, TAG)
}