package com.suning.epafusion.utils

import android.text.TextUtils
import android.webkit.CookieManager
import com.suning.epafusion.net.PaymentEnviromentConfig
import com.suning.mobile.epa.NetworkKits.net.VolleyRequestController
import com.suning.mobile.epa.kits.utils.LogUtils
import org.apache.http.impl.cookie.BasicClientCookie

/**
 * @author zhongchi
 * @date 2019/1/25 16:53
 */


@Synchronized
fun syncLocalCookie() {
    val url = PaymentEnviromentConfig.ftis2BasicUrl
    val cookieManager = CookieManager.getInstance()
    val cookieStr = cookieManager.getCookie(url)
    LogUtils.d("pasport cookieStr = $cookieStr")
    if (!TextUtils.isEmpty(cookieStr)) {
        val cookieList = cookieStr.split(";".toRegex()).dropLastWhile { it.isEmpty() }.toTypedArray()
        val cookieStore = VolleyRequestController.getInstance().cookieStore
        for (s in cookieList) {
            if (s.contains("EPPTGC")) {
                cookieStore.addCookie(BasicClientCookie("EPPTGC", s.substring(s.indexOf("=") + 1, s.length)))
            }
        }
        LogUtils.d("cookieStore = " + cookieStore.toString())
    }

}

fun clearLocalCookie(){
    CookieManager.getInstance().removeAllCookie()
    VolleyRequestController.getInstance().cookieStore.clear()
}